## 将GDK3开发成一个有趣的U盘
## 1.背景和基本目标
##### 编写固件，将GDK3开发成一个具有奇异功能的U盘（UDisk）。
## 2.基本功能开发步骤
##### （1）在gdk3\sdk\src目录下建立gedisk目录，从gem3下复制Makefile过来
##### （2）将沁恒EVT包的以下文件复制到gedisk目录
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_1678a87988d7c75303b47d7dabdb6781_r.png)
##### （3）修改gedisk目录下的Makefile，将程序名改为gedisk，加入上图中的.c文件，使用以前的方法进行编译
#####  温馨小提示：导入外源包，在编译过程中通常会出现很多问题，为了方便起见呢，我们已经在GDK3的SDK里准备好了一个gedisk(可以点击下面的链接进行下载)
https://gedu.oss-cn-beijing.aliyuncs.com/gdk3/gedisk.zip
#### 编译过程需执行的指令(这些路径输入都要根据自己的文件夹具体放在哪里哈！！！具体的操作，可以看看GDK3上手系列之三)
 ####    下面是编译示例操作：
-  ##### 设置工具链的路径
`export PATH=/d/GnuArmToolchain/bin/:$PATH`
-  ##### 切换到gedisk目录下，编译gedisk目录下的代码
`cd /d/work/gdk3sdk/src/gedisk`
-  ##### 输入make进行构建
`make`
编译通过，执行烧录操作。
#### 下面是烧录示例操作：
- ##### 将gedisk.hex烧录到gdk3
`!program D:\\work\\gdk3sdk\\src\\gedisk\\gedisk.hex`
-  ##### 重启gdk3
`！reset`
将GDK3的USB1口连到计算机（上位机），看是否可以成功识别到U盘,识别成功的话，下图的e盘就是我们的GDK3啦，现在我们来读取一下GDK3中的文件，将GDK3中的文件复制到我们的电脑上。
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_8d056a4d17b509d22d885b25ef23dfbd_r.png)
**补充一下哈：GDK3的USB1接口既可以连接主机又可以连接设备，USB2接口只能连接设备。**
## 增强功能之数据加密
修改写闪存的代码，将数据与固定的密钥GEDU2018做XOR（异或）操作，这样写到U盘上的数据再读出来就是乱码，在进行一次异或的话就可以解密。
```cpp
#include <iostream>
using namespace std;
#define MAXSIZE 100
void INCODE(char* str1,int n)
{
	uint8_t i;
	char b[] = "GEDU2018";
	for (i = 0; i < n; i++)
	{
		str1[i] = str1[i] ^ b[i%8];
		cout << str1[i];
	}
	cout << endl;
}
void DECODE(char* str2,int n)
{
	uint8_t i;
	char b[] = "GEDU2018";
	for (i = 0; i <n; i++)
	{
		str2[i] = str2[i] ^ b[i%8];
		cout << str2[i];
	}
	cout << endl;
}
int main()
{
	char a[MAXSIZE]="abcdefghigk12345678910";
	int n = strlen(a);
	INCODE(a,n);
	DECODE(a,n);
	return 0;
}
```
给大家看一下数据**"abcdefghigk12345678910"**进行加密和解密操作后的结果：
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_bd6471ba32f5c17b857d618b924fa85c_r.png)
##### 注意哦：如果我们要加密的数据长度如果超过8个字节的话，就会越界，因为密钥只有八个字节，所以密钥相当于反复在8个字节里循环，这样就需要我们来做一个取余的操作。
##### 想看具体的操作的话，可以点击下面的链接，观看视频讲解。
https://www.bilibili.com/video/BV1aW4y1u728/