## 用GDK3开发神奇的幽灵鼠标
## 目标
**把GDK3开发成一个特殊的鼠标设备，自动发送鼠标事件，这时从用户的角度看：电脑的鼠标像幽灵一样在屏幕上自己移动，非常之有趣。**
## 思路
**修改GDK3中运行的程序，让GDK3自动发送移动鼠标的命令，并使用其他主机测试GDK3的发送行为。**
## 开发过程
- ### 修改代码包
#### 1.建立本项目的项目文件夹，并把项目需要用到的源码复制过来。
**建立项目工作目录**
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_f030f9d01a0b3b7a35cec36203341a53_r.png)
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_6d40f9711626828e2e2df4b3e3ac3694_r.png)
#### 2.编写此项目的Makefile文件。
**编写注意事项：**
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_2c3c43aa65ac7508afc0bb791e2452df_r.png)
一般来说每个.h文件都对应着与其同名的.c文件，当某个源文件引入.h文件时，在Makefile中也要引入对应的.c文件。
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_c0c0fcbf788459dd8b2492043efe6613_r.png)
但是某些文件之间可能存在依赖关系，这时一定要注意引入文件的先后顺序。
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_5ba08a6c3807287f92def5833b403f22_r.png)
编写完Makefile之后，开始正式编译程序(注意：输入路径时要根据自己文件的位置，下面是示例操作）
- ### 编译操作
#### 1.双击打开MSYS2
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_bdbbe30eda73d105579c1106518173ec_r.png)
#### 2.设置工具链的路径
`export PATH=/d/gedu_work/GNU/bin/:$PATH`
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_53fcf5e9ea4880310994105a06a48cd6_r.png)
#### 3.切换到gemice3项目所在的目录(因为要编译gemice3文件夹下的代码，因此要切换到gemice3文件夹下的代码）
`cd /d/gedu_work/gdk3/sdk/src/gemice3/`
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_cc1476544fb8e967fc03b9c85bc8dfa1_r.png)
#### 4.输入make命令进行构建
`make`
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_499fccbbe0a007806c60f2ba507a596a_r.png)
出现以下结果就算编译成功
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_08e6c1beb128d426b37e6641407f3854_r.png)
编译成功后，用Nanocode和挥码枪将程序烧录到GDK3上。（烧录操作详情可以参考 GDK上手系列之三）
- ### 烧录操作
#### 1.输入下面的命令将程序烧录到GDK3上（注意：文件的路径要根据自己文件实际放置的位置,下面是示例操作）
`!program D:\\gedu_work\\gdk3\\sdk\\src\\gemice3\\gemice.hex`
#### 2.输入 reset 重启 GDK3
`!reset`
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_8a237b3c459321b294fbecb4808560d2_r.png)
**注意：GDK3的USB2要连接电脑主机  (此项目使用USBD控制器设备，也就是GDK3上的USB2口）**
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_a4057575b2dbb3ec1bb8b383f811e898_r.png)
- ### 测试操作
#### 1.测试GDK3运行该程序时，是否可作为USB设备被主机识别。
**打开usbview软件，观察主机接入GDK3的USB端口。（usbview 是一个usb设备查看器，能够对系统中全部的USB设备进行枚举，可以查看每个设备的详细信息）。**
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_9d7118821c3fe98f2e2d7ad7f4319e3d_r.png)
#### 2.确定识别成功后，修改程序的鼠标发送行为。
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_14472c68f3253129e3d4669d1a7e90aa_r.png)
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_7003fe044c767adf568b56669e5112c3_r.png)
#### 3.修改完成后 -> 重新编译 -> 重新烧录 -> 重新运行
#### 4.观察结果，点击下面链接，观看幽灵鼠标测试成功视频。

### http://c.nxw.so/83wR3

**此时并没有移动鼠标，但鼠标自己在移动，这说明GDK3在自动发送鼠标移动的命令，并且当前电脑主机可以接收并识别GDK3的命令。至此，项目测试成功！**
**我们也可以在这个鼠标自行移动的基础上，开发其他有趣好玩的项目，例如让鼠标画一个爱心❤，或者让键盘自己打字，从而让GDK3成为真正的幽灵。是不是很棒呢？**
## 总结：
**编译阶段遇到了许多错误，包括：文件缺失、变量未定义、变量重定义......突然从IDE的一键编译到自己开始编写编译命令，突然出现那么多报错。突然想放弃了，然后请教了老师和师兄。**
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_315a22727d92cb262ee0c6369745ba20_r.png)
**看到师兄的回答，我顿似醍醐灌顶。是的，使用IDE时遇到变量未定义的错误，解决办法是引入变量所在的文件，而使用gcc和make时，这个错误依然是这样解决，更何况编译器的报错都是简单直接的英文，自己好好分析下是可以理解的。有错误就有解决办法，按照师兄的指点，我开始一条一条的解决，果然，成功编译！**
**编译成功之后，我一直测试也没有成功。后来是张老师帮我找到了问题，原来：最开始引入源码的时候，我以为是完整健全的代码，可实际上引入的是已经被我修改过的代码（源码中好多功能和逻辑都不通了），我应该反思：不可以随处乱加代码。而且如果要修改某段源码时，最好是留有备份，以便事后的恢复和还原。**
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_790f4fb05db3b0ceae1e787303114fef_r.png)
##### 根据自己的错误，我写了一篇关于makefile详情的博客，大家如果有需要的话，可以点击下面的链接去参考。
### http://t.csdn.cn/AZqT7
### 最后：纸上得来终觉浅，绝知此事要躬行。干等解决不了问题，要有明确的目标和计划并对此付出行动！