## 背景介绍



USB转串口是常用的调试工具，可以实现计算机USB接口到通用串口之间的转换，使用USB转串口设备等于将传统的串口设备变成了即插即用的USB设备。这个文档将告诉我们如何将GDK3烧录成USB转串口，并进行测试。主要讲述了如何烧录gecdc程序到GDK3-US、烧录gem3程序到GDK3-DEV、连接两个GDK3，输出串口信息进行测试这几个过程。

------------



 ### 需要的设备
①挥码枪 ×1
②gdk3 ×2 (对两个gdk3分别命名为GDK3-DEV,GDK3-US)
③USB-typeC数据线
④杜邦线
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_6a25a76d48c44deb2ba32205e035f5c6_r.png)

  GDK3-DEV烧录可以输出打印信息的程序，输出串口信息，进行测试。
（可以烧录其它的程序进行测试，这个文档以烧录gem3程序为示例，给大家演示一下）

GDK3-US烧录gecdc文件夹下的程序，烧录成功后，此时，GDK3-US就相当于是一个USB转串口工具，可以帮助把串口信号转为USB信号。

------------


 

## 1.GDK3-US烧录gecdc程序
①在开始菜单选择MSYS2 MSYS,双击启动MSYS2命令窗口

![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_08d86f5e2d79f348bd0ad21a98cd3aad_r.png)

②执行命令`export PATH=路径:$PATH` 设置gnu arm工具链路径（下面的是一个示例，要设置您自己下载的arm工具链的路径哦）

`export PATH=/d/GnuArmToolchain/bin/:$PATH`

③切换到gdk3sdk的gem3所在目录（因为要编译gecdc文件中的代码，所以MSYS2 MSYS编译的文件路径要切换gecdc所在的目录哦，注意哦，依然是您下载的目录的路径哦，代码示例目录为D:\work\）

`cd /d/work/gdk3sdk/src/gecdc`

④执行make命令进行构建

`make`

![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_8d53d8d27b4eaebd5b4f9ade2994dfb3_r.png)

**注意：我们进行gecdc程序烧录前，可以打开电脑的设备管理器，查看端口设备，可以看到USB串行设备只有COM7,也就是我们的挥码枪。**

![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_79609bcb8a295fd5ef2bf3a7295d32bb_r.png)
`!program D:\\work\\gdk3sdk\\src\\gecdc\\gecdc.hex`

烧录成功后，重新启动一下gdk3

![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_35a1f1540eef82bf80571a8b1bd4d827_r.png)

此时，我们再打开电脑的设备管理器，可以看到我们的GDK3-US已经被烧录成USB转接口了。

![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_3f0227f856037568f3a477a92782250a_r.png)

## 2.GDK3-DEV烧录gem3程序。
①在开始菜单选择MSYS2 MSYS,双击启动MSYS2命令窗口
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_08d86f5e2d79f348bd0ad21a98cd3aad_r.png)

②执行命令`export PATH=路径:$PATH` 设置gnu arm工具链路径（下面的是一个示例，要设置您自己下载的arm工具链的路径哦）

`export PATH=/d/GnuArmToolchain/bin/:$PATH`

③切换到gdk3sdk的gem3所在目录（因为要编译gem3文件中的代码，所以MSYS2 MSYS编译的文件路径要切换gem3所在的目录哦，注意哦，依然是您下载的目录的路径哦，代码示例目录为D:\work\）

`cd /d/gdk3sdk/src/gem3`

④执行make命令进行构建

`make`

整个过程如下图所示
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_7c7f5985a4a2fdddc19bf649422fdbd0_r.png)
⑤打开nanocode进行烧录

`!program D:\\gdk3sdk\\src\\gem3\\gem3.hex`

烧录成功后，重新启动一下gdk3

`!reset`

![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_176c001bc56d8afdaafbb3e291ba241e_r.png)

## 3.连接两个GDK3，并进行测试。
两个gdk3的连接方式为：
GND-GND
TX-RX
RX-TX
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_a13260eb441ab431acfc07f4c634bf7e_r.png)
**然后将GDK3-US连接到主机上(注意GDK3-DEV的USB口先不要插到电脑上，否则串口信息打印不出来，在其他的线连接好，并打开putty软件，设置好putty，点击open之后，再将GDK3-DEV连接到电脑上）**

打开PuTTy,下面是示例操作

①在Session中，选Serial,设置串行路线，即GDK3-US烧录成USB串口后的端口号。

②设置Speed为`115200`

③在Saved Sessions输入GDK3-US的端口号

④点击open

可看下图操作

![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_7db2462825987823c3ada863fbd7c717_r.png)

点击open后，会出现下图的结果

![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_7ce33666cff5a3d012a32a77913906cc_r.png)

此时将GDK3-DEV的USB接口插到主机上，观察到下图的结果，测试成功！

![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_b5d7d960be5a2b6f0f0151f54f84d27a_r.png)

#### 温馨小提示：如果想要修改打印信息的话，可以在gem3.c文件中进行修改