# 背景介绍
NKM的全称是Nano Keyboard & Mouse，是基于GDK3硬件开发的一个输入设备，典型的用法是可以把笔记本电脑上的鼠标和键盘输入重定向到另一台机器，比如GDK8，并且可以在Nano显示器中直接输入鼠标键盘事件并发送给下位机（GDK8）。
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_2808599821633c6b3ae2b047b777350a_r.png)
# 操作步骤
## 1. 烧录nkm固件
首先下载[nkm固件](https://gedu.oss-cn-beijing.aliyuncs.com/gdk3/nkm/gekm.hex "nkm固件")，然后将GDK3与挥码枪连接好（可以参考[GDK3上手指南](https://www.nanocode.cn/wiki/docs/gdk3/gdk3-1e1rnu9kp23hu "GDK3上手指南")；需要将USB线与GDK3的USB2端口连接，用于供电和与上位机通信），然后打开Nano Code进入调试会话。
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_e92d40c1fdd5394eb3fefc29bbf43a29_r.png)
然后通过`!program [nkm固件路径]`命令烧录固件（注意路径需要2个反斜杠）。
```
!program D:\\Download\\gekm.hex

[ndb]!program D:\\Download\\gekm.hex
** Programming Started **
device id = 0x20000410
flash size = 64kbytes
** Programming Finished **
```
## 2. 查看nkm设备
完成烧录后，通过`!reset`、`.reboot`、`g`命令重启GDK3，然后等待nkm设备出现。
```
[ndb]!reset
No Debuggee
No Debuggee
.reboot
Shutdown occurred...unloading all symbol tables.
NDB session started in 13936:15916(0x3e2c)
OS meta is connected
Connected to unknown 2 ARM 32-bit, 32bit
Symbol search path is: D:\gdk8\symbol;TGT*c:\symbols*;srv*c:\symbols* http://msdl.microsoft.com/download/symbols
.ndb_note:gekm.elfKernel base < system range start
unknown Kernel Version 2 SMP (1 procs) free ARM 32-bit
Kernel base = 0x08000000 kernel module list = 0x00000000
System uptime: not available
lk+3380:
8003380 2100     movs	r1, #0
g
```
通过[usbview](https://learn.microsoft.com/en-us/windows-hardware/drivers/debugger/usbview)在 正常情况可以看到nkm的设备信息如下所示（如果不能枚举设备，请重新烧录固件；如果设备描述符信息中出现警告，可以尝试插拔USB线）。
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_338fe01a06ac0d43249ee2e43f8410c1_r.png)
## 3. 连接下位机
此时使用另一根USB线将下位机（GDK8）与GDK3的USB1端口进行连接。然后重启Nano Code并打开Nano 显示器。
如果检测不到设备Nano Code右下角会出现下面的提示信息。
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_af6200ff3230a889caafe41a2cf7b853_r.png)
## 4. 使用nkm
如果加载nkm设备没有问题，那么此时就可以在Nano 显示器中直接发送鼠标键盘按键给下位机（GDK8）了！
注意如果想要更加方便的使用组合键且不与上位机冲突，请保证nkm模式处于被勾选的状态。
![](https://www.nanocode.cn/wiki/uploads/gdk3/images/m_26344b851a56e04d7a49962ceed9764b_r.png)